

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>Inheritance &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="Inheritance.html#">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="Inheritance.html#">Inheritance</a><ul>
<li><a class="reference internal" href="Inheritance.html#ID194">Defining a Base Class</a></li>
<li><a class="reference internal" href="Inheritance.html#ID195">Subclassing</a></li>
<li><a class="reference internal" href="Inheritance.html#ID196">Overriding</a><ul>
<li><a class="reference internal" href="Inheritance.html#ID197">Accessing Superclass Methods, Properties, and Subscripts</a></li>
<li><a class="reference internal" href="Inheritance.html#ID198">Overriding Methods</a></li>
<li><a class="reference internal" href="Inheritance.html#ID199">Overriding Properties</a><ul>
<li><a class="reference internal" href="Inheritance.html#ID200">Overriding Property Getters and Setters</a></li>
<li><a class="reference internal" href="Inheritance.html#ID201">Overriding Property Observers</a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="Inheritance.html#ID202">Preventing Overrides</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="inheritance">
<h1>Inheritance<a class="headerlink" href="Inheritance.html#inheritance" title="Permalink to this headline"></a></h1>
<p>A class can <em>inherit</em> methods, properties, and other characteristics from another class. When one class inherits from another, the inheriting class is known as a <em>subclass</em>, and the class it inherits from is known as its <em>superclass</em>. Inheritance is a fundamental behavior that differentiates classes from other types in Swift.</p>
<p>Classes in Swift can call and access methods, properties, and subscripts belonging to their superclass and can provide their own overriding versions of those methods, properties, and subscripts to refine or modify their behavior. Swift helps to ensure your overrides are correct by checking that the override definition has a matching superclass definition.</p>
<p>Classes can also add property observers to inherited properties in order to be notified when the value of a property changes. Property observers can be added to any property, regardless of whether it was originally defined as a stored or computed property.</p>
<div class="section" id="ID194">
<h2>Defining a Base Class<a class="headerlink" href="Inheritance.html#ID194" title="Permalink to this headline"></a></h2>
<p>Any class that does not inherit from another class is known as a <em>base class</em>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Swift classes do not inherit from a universal base class. Classes you define without specifying a superclass automatically become base classes for you to build upon.</p>
</div>
<p>The example below defines a base class called <code class="docutils literal"><span class="pre">Vehicle</span></code>. This base class defines a stored property called <code class="docutils literal"><span class="pre">currentSpeed</span></code>, with a default value of <code class="docutils literal"><span class="pre">0.0</span></code> (inferring a property type of <code class="docutils literal"><span class="pre">Double</span></code>). The <code class="docutils literal"><span class="pre">currentSpeed</span></code> property’s value is used by a read-only computed <code class="docutils literal"><span class="pre">String</span></code> property called <code class="docutils literal"><span class="pre">description</span></code> to create a description of the vehicle.</p>
<p>The <code class="docutils literal"><span class="pre">Vehicle</span></code> base class also defines a method called <code class="docutils literal"><span class="pre">makeNoise</span></code>. This method does not actually do anything for a base <code class="docutils literal"><span class="pre">Vehicle</span></code> instance, but will be customized by subclasses of <code class="docutils literal"><span class="pre">Vehicle</span></code> later on:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Vehicle</span> {
</li><li>    <span class="k">var</span> <span class="nv">currentSpeed</span> = <span class="m">0.0</span>
</li><li>    <span class="k">var</span> <span class="nv">description</span>: <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&quot;traveling at </span>\<span class="p">(</span><span class="nv">currentSpeed</span><span class="p">)</span><span class="s"> miles per hour&quot;</span>
</li><li>    }
</li><li>    <span class="k">func</span> <span class="nv">makeNoise</span>() {
</li><li>        <span class="c">// do nothing - an arbitrary vehicle doesn&#39;t necessarily make a noise</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>You create a new instance of <code class="docutils literal"><span class="pre">Vehicle</span></code> with <em>initializer syntax</em>, which is written as a type name followed by empty parentheses:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">someVehicle</span> = <span class="nv">Vehicle</span>()
</li></ol></pre></div></div>
<p>Having created a new <code class="docutils literal"><span class="pre">Vehicle</span></code> instance, you can access its <code class="docutils literal"><span class="pre">description</span></code> property to print a human-readable description of the vehicle’s current speed:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&quot;Vehicle: </span>\<span class="p">(</span><span class="nv">someVehicle</span>.<span class="nv">description</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li><span class="c">// Vehicle: traveling at 0.0 miles per hour</span>
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">Vehicle</span></code> class defines common characteristics for an arbitrary vehicle, but is not much use in itself. To make it more useful, you need to refine it to describe more specific kinds of vehicles.</p>
</div>
<div class="section" id="ID195">
<h2>Subclassing<a class="headerlink" href="Inheritance.html#ID195" title="Permalink to this headline"></a></h2>
<p><em>Subclassing</em> is the act of basing a new class on an existing class. The subclass inherits characteristics from the existing class, which you can then refine. You can also add new characteristics to the subclass.</p>
<p>To indicate that a subclass has a superclass, write the subclass name before the superclass name, separated by a colon:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">SomeSubclass</span>: <span class="nc">SomeSuperclass</span> {
</li><li>    <span class="c">// subclass definition goes here</span>
</li><li>}
</li></ol></pre></div></div>
<p>The following example defines a subclass called <code class="docutils literal"><span class="pre">Bicycle</span></code>, with a superclass of <code class="docutils literal"><span class="pre">Vehicle</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Bicycle</span>: <span class="nc">Vehicle</span> {
</li><li>    <span class="k">var</span> <span class="nv">hasBasket</span> = <span class="k">false</span>
</li><li>}
</li></ol></pre></div></div>
<p>The new <code class="docutils literal"><span class="pre">Bicycle</span></code> class automatically gains all of the characteristics of <code class="docutils literal"><span class="pre">Vehicle</span></code>, such as its <code class="docutils literal"><span class="pre">currentSpeed</span></code> and <code class="docutils literal"><span class="pre">description</span></code> properties and its <code class="docutils literal"><span class="pre">makeNoise()</span></code> method.</p>
<p>In addition to the characteristics it inherits, the <code class="docutils literal"><span class="pre">Bicycle</span></code> class defines a new stored property, <code class="docutils literal"><span class="pre">hasBasket</span></code>, with a default value of <code class="docutils literal"><span class="pre">false</span></code> (inferring a type of <code class="docutils literal"><span class="pre">Bool</span></code> for the property).</p>
<p>By default, any new <code class="docutils literal"><span class="pre">Bicycle</span></code> instance you create will not have a basket. You can set the <code class="docutils literal"><span class="pre">hasBasket</span></code> property to <code class="docutils literal"><span class="pre">true</span></code> for a particular <code class="docutils literal"><span class="pre">Bicycle</span></code> instance after that instance is created:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">bicycle</span> = <span class="nv">Bicycle</span>()
</li><li><span class="nv">bicycle</span>.<span class="nv">hasBasket</span> = <span class="k">true</span>
</li></ol></pre></div></div>
<p>You can also modify the inherited <code class="docutils literal"><span class="pre">currentSpeed</span></code> property of a <code class="docutils literal"><span class="pre">Bicycle</span></code> instance, and query the instance’s inherited <code class="docutils literal"><span class="pre">description</span></code> property:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">bicycle</span>.<span class="nv">currentSpeed</span> = <span class="m">15.0</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;Bicycle: </span>\<span class="p">(</span><span class="nv">bicycle</span>.<span class="nv">description</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li><span class="c">// Bicycle: traveling at 15.0 miles per hour</span>
</li></ol></pre></div></div>
<p>Subclasses can themselves be subclassed. The next example creates a subclass of <code class="docutils literal"><span class="pre">Bicycle</span></code> for a two-seater bicycle known as a “tandem”:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Tandem</span>: <span class="nc">Bicycle</span> {
</li><li>    <span class="k">var</span> <span class="nv">currentNumberOfPassengers</span> = <span class="m">0</span>
</li><li>}
</li></ol></pre></div></div>
<p><code class="docutils literal"><span class="pre">Tandem</span></code> inherits all of the properties and methods from <code class="docutils literal"><span class="pre">Bicycle</span></code>, which in turn inherits all of the properties and methods from <code class="docutils literal"><span class="pre">Vehicle</span></code>. The <code class="docutils literal"><span class="pre">Tandem</span></code> subclass also adds a new stored property called <code class="docutils literal"><span class="pre">currentNumberOfPassengers</span></code>, with a default value of <code class="docutils literal"><span class="pre">0</span></code>.</p>
<p>If you create an instance of <code class="docutils literal"><span class="pre">Tandem</span></code>, you can work with any of its new and inherited properties, and query the read-only <code class="docutils literal"><span class="pre">description</span></code> property it inherits from <code class="docutils literal"><span class="pre">Vehicle</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">tandem</span> = <span class="nv">Tandem</span>()
</li><li><span class="nv">tandem</span>.<span class="nv">hasBasket</span> = <span class="k">true</span>
</li><li><span class="nv">tandem</span>.<span class="nv">currentNumberOfPassengers</span> = <span class="m">2</span>
</li><li><span class="nv">tandem</span>.<span class="nv">currentSpeed</span> = <span class="m">22.0</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;Tandem: </span>\<span class="p">(</span><span class="nv">tandem</span>.<span class="nv">description</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li><span class="c">// Tandem: traveling at 22.0 miles per hour</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID196">
<h2>Overriding<a class="headerlink" href="Inheritance.html#ID196" title="Permalink to this headline"></a></h2>
<p>A subclass can provide its own custom implementation of an instance method, type method, instance property, type property, or subscript that it would otherwise inherit from a superclass. This is known as <em>overriding</em>.</p>
<p>To override a characteristic that would otherwise be inherited, you prefix your overriding definition with the <code class="docutils literal"><span class="pre">override</span></code> keyword. Doing so clarifies that you intend to provide an override and have not provided a matching definition by mistake. Overriding by accident can cause unexpected behavior, and any overrides without the <code class="docutils literal"><span class="pre">override</span></code> keyword are diagnosed as an error when your code is compiled.</p>
<p>The <code class="docutils literal"><span class="pre">override</span></code> keyword also prompts the Swift compiler to check that your overriding class’s superclass (or one of its parents) has a declaration that matches the one you provided for the override. This check ensures that your overriding definition is correct.</p>
<div class="section" id="ID197">
<h3>Accessing Superclass Methods, Properties, and Subscripts<a class="headerlink" href="Inheritance.html#ID197" title="Permalink to this headline"></a></h3>
<p>When you provide a method, property, or subscript override for a subclass, it is sometimes useful to use the existing superclass implementation as part of your override. For example, you can refine the behavior of that existing implementation, or store a modified value in an existing inherited variable.</p>
<p>Where this is appropriate, you access the superclass version of a method, property, or subscript by using the <code class="docutils literal"><span class="pre">super</span></code> prefix:</p>
<ul class="simple">
<li>An overridden method named <code class="docutils literal"><span class="pre">someMethod()</span></code> can call the superclass version of <code class="docutils literal"><span class="pre">someMethod()</span></code> by calling <code class="docutils literal"><span class="pre">super.someMethod()</span></code> within the overriding method implementation.</li>
<li>An overridden property called <code class="docutils literal"><span class="pre">someProperty</span></code> can access the superclass version of <code class="docutils literal"><span class="pre">someProperty</span></code> as <code class="docutils literal"><span class="pre">super.someProperty</span></code> within the overriding getter or setter implementation.</li>
<li>An overridden subscript for <code class="docutils literal"><span class="pre">someIndex</span></code> can access the superclass version of the same subscript as <code class="docutils literal"><span class="pre">super[someIndex]</span></code> from within the overriding subscript implementation.</li>
</ul>
</div>
<div class="section" id="ID198">
<h3>Overriding Methods<a class="headerlink" href="Inheritance.html#ID198" title="Permalink to this headline"></a></h3>
<p>You can override an inherited instance or type method to provide a tailored or alternative implementation of the method within your subclass.</p>
<p>The following example defines a new subclass of <code class="docutils literal"><span class="pre">Vehicle</span></code> called <code class="docutils literal"><span class="pre">Train</span></code>, which overrides the <code class="docutils literal"><span class="pre">makeNoise()</span></code> method that <code class="docutils literal"><span class="pre">Train</span></code> inherits from <code class="docutils literal"><span class="pre">Vehicle</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Train</span>: <span class="nc">Vehicle</span> {
</li><li>    <span class="k">override</span> <span class="k">func</span> <span class="nv">makeNoise</span>() {
</li><li>        <span class="nv">print</span>(<span class="s">&quot;Choo Choo&quot;</span>)
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>If you create a new instance of <code class="docutils literal"><span class="pre">Train</span></code> and call its <code class="docutils literal"><span class="pre">makeNoise()</span></code> method, you can see that the <code class="docutils literal"><span class="pre">Train</span></code> subclass version of the method is called:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">train</span> = <span class="nv">Train</span>()
</li><li><span class="nv">train</span>.<span class="nv">makeNoise</span>()
</li><li><span class="c">// Prints &quot;Choo Choo&quot;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID199">
<h3>Overriding Properties<a class="headerlink" href="Inheritance.html#ID199" title="Permalink to this headline"></a></h3>
<p>You can override an inherited instance or type property to provide your own custom getter and setter for that property, or to add property observers to enable the overriding property to observe when the underlying property value changes.</p>
<div class="section" id="ID200">
<h4>Overriding Property Getters and Setters<a class="headerlink" href="Inheritance.html#ID200" title="Permalink to this headline"></a></h4>
<p>You can provide a custom getter (and setter, if appropriate) to override <em>any</em> inherited property, regardless of whether the inherited property is implemented as a stored or computed property at source. The stored or computed nature of an inherited property is not known by a subclass—it only knows that the inherited property has a certain name and type. You must always state both the name and the type of the property you are overriding, to enable the compiler to check that your override matches a superclass property with the same name and type.</p>
<p>You can present an inherited read-only property as a read-write property by providing both a getter and a setter in your subclass property override. You cannot, however, present an inherited read-write property as a read-only property.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If you provide a setter as part of a property override, you must also provide a getter for that override. If you don’t want to modify the inherited property’s value within the overriding getter, you can simply pass through the inherited value by returning <code class="docutils literal"><span class="pre">super.someProperty</span></code> from the getter, where <code class="docutils literal"><span class="pre">someProperty</span></code> is the name of the property you are overriding.</p>
</div>
<p>The following example defines a new class called <code class="docutils literal"><span class="pre">Car</span></code>, which is a subclass of <code class="docutils literal"><span class="pre">Vehicle</span></code>. The <code class="docutils literal"><span class="pre">Car</span></code> class introduces a new stored property called <code class="docutils literal"><span class="pre">gear</span></code>, with a default integer value of <code class="docutils literal"><span class="pre">1</span></code>. The <code class="docutils literal"><span class="pre">Car</span></code> class also overrides the <code class="docutils literal"><span class="pre">description</span></code> property it inherits from <code class="docutils literal"><span class="pre">Vehicle</span></code>, to provide a custom description that includes the current gear:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Car</span>: <span class="nc">Vehicle</span> {
</li><li>    <span class="k">var</span> <span class="nv">gear</span> = <span class="m">1</span>
</li><li>    <span class="k">override</span> <span class="k">var</span> <span class="nv">description</span>: <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="k">super</span>.<span class="nv">description</span> + <span class="s">&quot; in gear </span>\<span class="p">(</span><span class="nv">gear</span><span class="p">)</span><span class="s">&quot;</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The override of the <code class="docutils literal"><span class="pre">description</span></code> property starts by calling <code class="docutils literal"><span class="pre">super.description</span></code>, which returns the <code class="docutils literal"><span class="pre">Vehicle</span></code> class’s <code class="docutils literal"><span class="pre">description</span></code> property. The <code class="docutils literal"><span class="pre">Car</span></code> class’s version of <code class="docutils literal"><span class="pre">description</span></code> then adds some extra text onto the end of this description to provide information about the current gear.</p>
<p>If you create an instance of the <code class="docutils literal"><span class="pre">Car</span></code> class and set its <code class="docutils literal"><span class="pre">gear</span></code> and <code class="docutils literal"><span class="pre">currentSpeed</span></code> properties, you can see that its <code class="docutils literal"><span class="pre">description</span></code> property returns the tailored description defined within the <code class="docutils literal"><span class="pre">Car</span></code> class:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">car</span> = <span class="nv">Car</span>()
</li><li><span class="nv">car</span>.<span class="nv">currentSpeed</span> = <span class="m">25.0</span>
</li><li><span class="nv">car</span>.<span class="nv">gear</span> = <span class="m">3</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;Car: </span>\<span class="p">(</span><span class="nv">car</span>.<span class="nv">description</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li><span class="c">// Car: traveling at 25.0 miles per hour in gear 3</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID201">
<h4>Overriding Property Observers<a class="headerlink" href="Inheritance.html#ID201" title="Permalink to this headline"></a></h4>
<p>You can use property overriding to add property observers to an inherited property. This enables you to be notified when the value of an inherited property changes, regardless of how that property was originally implemented. For more information on property observers, see <a class="reference internal" href="Properties.html#ID262"><span class="std std-ref">Property Observers</span></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>You cannot add property observers to inherited constant stored properties or inherited read-only computed properties. The value of these properties cannot be set, and so it is not appropriate to provide a <code class="docutils literal"><span class="pre">willSet</span></code> or <code class="docutils literal"><span class="pre">didSet</span></code> implementation as part of an override.</p>
<p class="last">Note also that you cannot provide both an overriding setter and an overriding property observer for the same property. If you want to observe changes to a property’s value, and you are already providing a custom setter for that property, you can simply observe any value changes from within the custom setter.</p>
</div>
<p>The following example defines a new class called <code class="docutils literal"><span class="pre">AutomaticCar</span></code>, which is a subclass of <code class="docutils literal"><span class="pre">Car</span></code>. The <code class="docutils literal"><span class="pre">AutomaticCar</span></code> class represents a car with an automatic gearbox, which automatically selects an appropriate gear to use based on the current speed:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">AutomaticCar</span>: <span class="nc">Car</span> {
</li><li>    <span class="k">override</span> <span class="k">var</span> <span class="nv">currentSpeed</span>: <span class="nc">Double</span> {
</li><li>        <span class="k">didSet</span> {
</li><li>            <span class="nv">gear</span> = <span class="nv">Int</span>(<span class="nv">currentSpeed</span> / <span class="m">10.0</span>) + <span class="m">1</span>
</li><li>        }
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>Whenever you set the <code class="docutils literal"><span class="pre">currentSpeed</span></code> property of an <code class="docutils literal"><span class="pre">AutomaticCar</span></code> instance, the property’s <code class="docutils literal"><span class="pre">didSet</span></code> observer sets the instance’s <code class="docutils literal"><span class="pre">gear</span></code> property to an appropriate choice of gear for the new speed. Specifically, the property observer chooses a gear that is the new <code class="docutils literal"><span class="pre">currentSpeed</span></code> value divided by <code class="docutils literal"><span class="pre">10</span></code>, rounded down to the nearest integer, plus <code class="docutils literal"><span class="pre">1</span></code>. A speed of <code class="docutils literal"><span class="pre">35.0</span></code> produces a gear of <code class="docutils literal"><span class="pre">4</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">automatic</span> = <span class="nv">AutomaticCar</span>()
</li><li><span class="nv">automatic</span>.<span class="nv">currentSpeed</span> = <span class="m">35.0</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;AutomaticCar: </span>\<span class="p">(</span><span class="nv">automatic</span>.<span class="nv">description</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li><span class="c">// AutomaticCar: traveling at 35.0 miles per hour in gear 4</span>
</li></ol></pre></div></div>
</div>
</div>
</div>
<div class="section" id="ID202">
<h2>Preventing Overrides<a class="headerlink" href="Inheritance.html#ID202" title="Permalink to this headline"></a></h2>
<p>You can prevent a method, property, or subscript from being overridden by marking it as <em>final</em>. Do this by writing the <code class="docutils literal"><span class="pre">final</span></code> modifier before the method, property, or subscript’s introducer keyword (such as <code class="docutils literal"><span class="pre">final</span> <span class="pre">var</span></code>, <code class="docutils literal"><span class="pre">final</span> <span class="pre">func</span></code>, <code class="docutils literal"><span class="pre">final</span> <span class="pre">class</span> <span class="pre">func</span></code>, and <code class="docutils literal"><span class="pre">final</span> <span class="pre">subscript</span></code>).</p>
<p>Any attempt to override a final method, property, or subscript in a subclass is reported as a compile-time error. Methods, properties, or subscripts that you add to a class in an extension can also be marked as final within the extension’s definition.</p>
<p>You can mark an entire class as final by writing the <code class="docutils literal"><span class="pre">final</span></code> modifier before the <code class="docutils literal"><span class="pre">class</span></code> keyword in its class definition (<code class="docutils literal"><span class="pre">final</span> <span class="pre">class</span></code>). Any attempt to subclass a final class is reported as a compile-time error.</p>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="Subscripts.html">Subscripts</a></p>
        <p class="next"><a href="Initialization.html">Initialization</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
